Attribute VB_Name = "MciCommandConstants"
Option Explicit

'==================================================================
'
' Constans and Structures for MCI send command constant
'
' 30 September 2001
'
' You're free in using this software, as long as the
' orignal copyright/author information remains intact.
' In other words, respecting the person(s) who made it
' possible for you to view/learn something of this software.
'
' Copyright  2001 - Diederik van der Boor
' http://www.codingdomain.com
'
'==================================================================


Public Enum MCIMiscConstants
  MCI_ERR_BASE = 256
  MCI_STRING_OFFSET = 512  ' if this number is changed you MUST alter the MCI_DEVTYPE_... list below
  MCI_VD_OFFSET = 1024
  MCI_CD_OFFSET = 1088
  MCI_WAVE_OFFSET = 1152
  MCI_SEQ_OFFSET = 1216
  MCI_VD_MODE_PARK = (MCI_VD_OFFSET + 1)
  MCI_WAVE_PCM = (MCI_WAVE_OFFSET + 0)
  MCI_WAVE_MAPPER = (MCI_WAVE_OFFSET + 1)
End Enum

Public Enum MCICommonCommands
'  Message numbers must be in the range between MCI_FIRST and MCI_LAST

  MCI_FIRST = &H800
'  Messages 0x801 and 0x802 are reserved
  MCI_OPEN = &H803
  MCI_CLOSE = &H804
  MCI_ESCAPE = &H805
  MCI_PLAY = &H806
  MCI_SEEK = &H807
  MCI_STOP = &H808
  MCI_PAUSE = &H809
  MCI_INFO = &H80A
  MCI_GETDEVCAPS = &H80B
  MCI_SPIN = &H80C
  MCI_SET = &H80D
  MCI_STEP = &H80E
  MCI_RECORD = &H80F
  MCI_SYSINFO = &H810
  MCI_BREAK = &H811
  MCI_SOUND = &H812
  MCI_SAVE = &H813
  MCI_STATUS = &H814

  MCI_CUE = &H830

  MCI_REALIZE = &H840
  MCI_WINDOW = &H841
  MCI_PUT = &H842
  MCI_WHERE = &H843
  MCI_FREEZE = &H844
  MCI_UNFREEZE = &H845

  MCI_LOAD = &H850
  MCI_CUT = &H851
  MCI_COPY = &H852
  MCI_PASTE = &H853
  MCI_UPDATE = &H854
  MCI_RESUME = &H855
  MCI_DELETE = &H856

  MCI_LAST = &HFFF
  
  MM_MCINOTIFY = &H3B9
  MM_MCISIGNAL = &H3CB
  MCI_USER_MESSAGES = (&H400 + MCI_FIRST)
End Enum

Public Enum MCIStatusCmdStructResult_ModeFlag
  MCI_MODE_NOT_READY = (MCI_STRING_OFFSET + 12)
  MCI_MODE_STOP = (MCI_STRING_OFFSET + 13)
  MCI_MODE_PLAY = (MCI_STRING_OFFSET + 14)
  MCI_MODE_RECORD = (MCI_STRING_OFFSET + 15)
  MCI_MODE_SEEK = (MCI_STRING_OFFSET + 16)
  MCI_MODE_PAUSE = (MCI_STRING_OFFSET + 17)
  MCI_MODE_OPEN = (MCI_STRING_OFFSET + 18)
End Enum

Public Enum MCIStatusCmdFlags
  MCI_STATUS_ITEM = &H100&
  MCI_STATUS_START = &H200&
End Enum

Public Enum MCISetCmdStructTimeFormatFlags
  MCI_FORMAT_MILLISECONDS = 0
  MCI_FORMAT_HMS = 1
  MCI_FORMAT_MSF = 2
  MCI_FORMAT_FRAMES = 3
  MCI_FORMAT_SMPTE_24 = 4
  MCI_FORMAT_SMPTE_25 = 5
  MCI_FORMAT_SMPTE_30 = 6
  MCI_FORMAT_SMPTE_30DROP = 7
  MCI_FORMAT_BYTES = 8
  MCI_FORMAT_SAMPLES = 9
  MCI_FORMAT_TMSF = 10
End Enum

Public Enum MCIOpenCmdFlags
  MCI_OPEN_SHAREABLE = &H100&
  MCI_OPEN_ELEMENT = &H200&
  MCI_OPEN_ALIAS = &H400&
  MCI_OPEN_ELEMENT_ID = &H800&
  MCI_OPEN_TYPE_ID = &H1000&
  MCI_OPEN_TYPE = &H2000&
End Enum

Public Enum MCINotifyMsgParams
  MCI_NOTIFY_SUCCESSFUL = &H1
  MCI_NOTIFY_SUPERSEDED = &H2
  MCI_NOTIFY_ABORTED = &H4
  MCI_NOTIFY_FAILURE = &H8
End Enum

Public Enum MCICommonCmdFlags
  MCI_NOTIFY = &H1&
  MCI_WAIT = &H2&
  MCI_FROM = &H4&
  MCI_TO = &H8&
  MCI_TRACK = &H10&
'  MCI_TEST = ?
End Enum

Public Enum MCISeekCmdFlags
  MCI_SEEK_TO_START = &H100&
  MCI_SEEK_TO_END = &H200&
End Enum

Public Enum MCIStatusCmdStructItemFlags
  MCI_STATUS_LENGTH = &H1&
  MCI_STATUS_POSITION = &H2&
  MCI_STATUS_NUMBER_OF_TRACKS = &H3&
  MCI_STATUS_MODE = &H4&
  MCI_STATUS_MEDIA_PRESENT = &H5&
  MCI_STATUS_TIME_FORMAT = &H6&
  MCI_STATUS_READY = &H7&
  MCI_STATUS_CURRENT_TRACK = &H8&
End Enum

Public Enum MCIInfoCmdFlags
  MCI_INFO_PRODUCT = &H100&
  MCI_INFO_FILE = &H200&
End Enum

Public Enum MCIGetdevcapsCmdFlags
  MCI_GETDEVCAPS_ITEM = &H100&
End Enum

Public Enum MCIGetdevcapsCmdStructItemFlags
  MCI_GETDEVCAPS_CAN_RECORD = &H1&
  MCI_GETDEVCAPS_HAS_AUDIO = &H2&
  MCI_GETDEVCAPS_HAS_VIDEO = &H3&
  MCI_GETDEVCAPS_DEVICE_TYPE = &H4&
  MCI_GETDEVCAPS_USES_FILES = &H5&
  MCI_GETDEVCAPS_COMPOUND_DEVICE = &H6&
  MCI_GETDEVCAPS_CAN_EJECT = &H7&
  MCI_GETDEVCAPS_CAN_PLAY = &H8&
  MCI_GETDEVCAPS_CAN_SAVE = &H9&
End Enum

Public Enum MCISysinfoCmdFlags
  MCI_SYSINFO_QUANTITY = &H100&
  MCI_SYSINFO_OPEN = &H200&
  MCI_SYSINFO_NAME = &H400&
  MCI_SYSINFO_INSTALLNAME = &H800&
End Enum

Public Enum MCISetCmdFlags
  MCI_SET_DOOR_OPEN = &H100&
  MCI_SET_DOOR_CLOSED = &H200&
  MCI_SET_TIME_FORMAT = &H400&
  MCI_SET_AUDIO = &H800&
  MCI_SET_VIDEO = &H1000&
  MCI_SET_ON = &H2000&
  MCI_SET_OFF = &H4000&
End Enum

Public Enum MCISetCmdStructAudioFlags ' flags for dwAudio field of MCI_SET_PARMS or MCI_SEQ_SET_PARMS
  MCI_SET_AUDIO_ALL = &H4001&
  MCI_SET_AUDIO_LEFT = &H4002&
  MCI_SET_AUDIO_RIGHT = &H4003&
End Enum

Public Enum MCIBreakCmdFlags
  MCI_BREAK_KEY = &H100&
  MCI_BREAK_HWND = &H200&
  MCI_BREAK_OFF = &H400&
End Enum

Public Enum MCIRecordCmdFlags
  MCI_RECORD_INSERT = &H100&
  MCI_RECORD_OVERWRITE = &H200&
End Enum

Public Enum MCISoundCmdFlags
  MCI_SOUND_NAME = &H100&
End Enum

Public Enum MCILoadSaveCmdFlags
  MCI_SAVE_FILE = &H100&
  MCI_LOAD_FILE = &H100&
End Enum

Public Enum MCICmdsVDDevFlags
'  return ID's for videodisc MCI_GETDEVCAPS command

'  flag for dwReturn field of MCI_STATUS_PARMS
'  MCI_STATUS command, (dwItem == MCI_VD_STATUS_MEDIA_TYPE)
  MCI_VD_MEDIA_CLV = (MCI_VD_OFFSET + 2)
  MCI_VD_MEDIA_CAV = (MCI_VD_OFFSET + 3)
  MCI_VD_MEDIA_OTHER = (MCI_VD_OFFSET + 4)

  MCI_VD_FORMAT_TRACK = &H4001

'  flags for dwFlags parameter of MCI_PLAY command message
  MCI_VD_PLAY_REVERSE = &H10000
  MCI_VD_PLAY_FAST = &H20000
  MCI_VD_PLAY_SPEED = &H40000
  MCI_VD_PLAY_SCAN = &H80000
  MCI_VD_PLAY_SLOW = &H100000

'  flag for dwFlags parameter of MCI_SEEK command message
  MCI_VD_SEEK_REVERSE = &H10000

'  flags for dwItem field of MCI_STATUS_PARMS parameter block
  MCI_VD_STATUS_SPEED = &H4002&
  MCI_VD_STATUS_FORWARD = &H4003&
  MCI_VD_STATUS_MEDIA_Type = &H4004&
  MCI_VD_STATUS_SIDE = &H4005&
  MCI_VD_STATUS_DISC_SIZE = &H4006&

'  flags for dwFlags parameter of MCI_GETDEVCAPS command message
  MCI_VD_GETDEVCAPS_CLV = &H10000
  MCI_VD_GETDEVCAPS_CAV = &H20000

  MCI_VD_SPIN_UP = &H10000
  MCI_VD_SPIN_DOWN = &H20000

'  flags for dwItem field of MCI_GETDEVCAPS_PARMS parameter block
  MCI_VD_GETDEVCAPS_CAN_REVERSE = &H4002&
  MCI_VD_GETDEVCAPS_FAST_RATE = &H4003&
  MCI_VD_GETDEVCAPS_SLOW_RATE = &H4004&
  MCI_VD_GETDEVCAPS_NORMAL_RATE = &H4005&

'  flags for the dwFlags parameter of MCI_STEP command message
  MCI_VD_STEP_FRAMES = &H10000
  MCI_VD_STEP_REVERSE = &H20000

'  flag for the MCI_ESCAPE command message
  MCI_VD_ESCAPE_STRING = &H100&
End Enum

Public Enum MCICmdsWaveDevFlags
'  flags for the dwFlags parameter of MCI_OPEN command message
  MCI_WAVE_OPEN_BUFFER = &H10000

'  flags for the dwFlags parameter of MCI_SET command message
  MCI_WAVE_SET_FORMATTAG = &H10000
  MCI_WAVE_SET_CHANNELS = &H20000
  MCI_WAVE_SET_SAMPLESPERSEC = &H40000
  MCI_WAVE_SET_AVGBYTESPERSEC = &H80000
  MCI_WAVE_SET_BLOCKALIGN = &H100000
  MCI_WAVE_SET_BITSPERSAMPLE = &H200000

'  flags for the dwFlags parameter of MCI_STATUS, MCI_SET command messages
  MCI_WAVE_INPUT = &H400000
  MCI_WAVE_OUTPUT = &H800000

'  flags for the dwItem field of MCI_STATUS_PARMS parameter block
  MCI_WAVE_STATUS_FORMATTAG = &H4001&
  MCI_WAVE_STATUS_CHANNELS = &H4002&
  MCI_WAVE_STATUS_SAMPLESPERSEC = &H4003&
  MCI_WAVE_STATUS_AVGBYTESPERSEC = &H4004&
  MCI_WAVE_STATUS_BLOCKALIGN = &H4005&
  MCI_WAVE_STATUS_BITSPERSAMPLE = &H4006&
  MCI_WAVE_STATUS_LEVEL = &H4007&

'  flags for the dwFlags parameter of MCI_SET command message
  MCI_WAVE_SET_ANYINPUT = &H4000000
  MCI_WAVE_SET_ANYOUTPUT = &H8000000

'  flags for the dwFlags parameter of MCI_GETDEVCAPS command message
  MCI_WAVE_GETDEVCAPS_INPUTS = &H4001&
  MCI_WAVE_GETDEVCAPS_OUTPUTS = &H4002&
End Enum

Public Enum MCICmdsMidiDevFlags
  MCI_SEQ_DIV_PPQN = (0 + MCI_SEQ_OFFSET)
  MCI_SEQ_DIV_SMPTE_24 = (1 + MCI_SEQ_OFFSET)
  MCI_SEQ_DIV_SMPTE_25 = (2 + MCI_SEQ_OFFSET)
  MCI_SEQ_DIV_SMPTE_30DROP = (3 + MCI_SEQ_OFFSET)
  MCI_SEQ_DIV_SMPTE_30 = (4 + MCI_SEQ_OFFSET)

'  flags for the dwMaster field of MCI_SEQ_SET_PARMS parameter block
'  MCI_SET command, (dwFlags == MCI_SEQ_SET_MASTER)
  MCI_SEQ_FORMAT_SONGPTR = &H4001
  MCI_SEQ_FILE = &H4002
  MCI_SEQ_MIDI = &H4003
  MCI_SEQ_SMPTE = &H4004
  MCI_SEQ_NONE = 65533

  MCI_SEQ_MAPPER = 65535

'  flags for the dwItem field of MCI_STATUS_PARMS parameter block
  MCI_SEQ_STATUS_TEMPO = &H4002&
  MCI_SEQ_STATUS_PORT = &H4003&
  MCI_SEQ_STATUS_SLAVE = &H4007&
  MCI_SEQ_STATUS_MASTER = &H4008&
  MCI_SEQ_STATUS_OFFSET = &H4009&
  MCI_SEQ_STATUS_DIVType = &H400A&

'  flags for the dwFlags parameter of MCI_SET command message
  MCI_SEQ_SET_TEMPO = &H10000
  MCI_SEQ_SET_PORT = &H20000
  MCI_SEQ_SET_SLAVE = &H40000
  MCI_SEQ_SET_MASTER = &H80000
  MCI_SEQ_SET_OFFSET = &H1000000
End Enum

Public Enum MCICmdsAnimDevFlags
'  flags for dwFlags parameter of MCI_OPEN command message
  MCI_ANIM_OPEN_WS = &H10000
  MCI_ANIM_OPEN_PARENT = &H20000
  MCI_ANIM_OPEN_NOSTATIC = &H40000

'  flags for dwFlags parameter of MCI_PLAY command message
  MCI_ANIM_PLAY_SPEED = &H10000
  MCI_ANIM_PLAY_REVERSE = &H20000
  MCI_ANIM_PLAY_FAST = &H40000
  MCI_ANIM_PLAY_SLOW = &H80000
  MCI_ANIM_PLAY_SCAN = &H100000

'  flags for dwFlags parameter of MCI_STEP command message
  MCI_ANIM_STEP_REVERSE = &H10000
  MCI_ANIM_STEP_FRAMES = &H20000

'  flags for dwItem field of MCI_STATUS_PARMS parameter block
  MCI_ANIM_STATUS_SPEED = &H4001&
  MCI_ANIM_STATUS_FORWARD = &H4002&
  MCI_ANIM_STATUS_HWND = &H4003&
  MCI_ANIM_STATUS_HPAL = &H4004&
  MCI_ANIM_STATUS_STRETCH = &H4005&

'  flags for the dwFlags parameter of MCI_INFO command message
  MCI_ANIM_INFO_TEXT = &H10000

'  flags for dwItem field of MCI_GETDEVCAPS_PARMS parameter block
  MCI_ANIM_GETDEVCAPS_CAN_REVERSE = &H4001&
  MCI_ANIM_GETDEVCAPS_FAST_RATE = &H4002&
  MCI_ANIM_GETDEVCAPS_SLOW_RATE = &H4003&
  MCI_ANIM_GETDEVCAPS_NORMAL_RATE = &H4004&
  MCI_ANIM_GETDEVCAPS_PALETTES = &H4006&
  MCI_ANIM_GETDEVCAPS_CAN_STRETCH = &H4007&
  MCI_ANIM_GETDEVCAPS_MAX_WINDOWS = &H4008&

'  flags for the MCI_REALIZE command message
  MCI_ANIM_REALIZE_NORM = &H10000
  MCI_ANIM_REALIZE_BKGD = &H20000

'  flags for dwFlags parameter of MCI_WINDOW command message
  MCI_ANIM_WINDOW_HWND = &H10000
  MCI_ANIM_WINDOW_STATE = &H40000
  MCI_ANIM_WINDOW_TEXT = &H80000
  MCI_ANIM_WINDOW_ENABLE_STRETCH = &H100000
  MCI_ANIM_WINDOW_DISABLE_STRETCH = &H200000

'  flags for hWnd field of MCI_ANIM_WINDOW_PARMS parameter block
'  MCI_WINDOW command message, (dwFlags == MCI_ANIM_WINDOW_HWND)
  MCI_ANIM_WINDOW_DEFAULT = &H0&

'  flags for dwFlags parameter of MCI_PUT command message
  MCI_ANIM_RECT = &H10000
  MCI_ANIM_PUT_SOURCE = &H20000      '  also  MCI_WHERE
  MCI_ANIM_PUT_DESTINATION = &H40000      '  also  MCI_WHERE

'  flags for dwFlags parameter of MCI_WHERE command message
  MCI_ANIM_WHERE_SOURCE = &H20000
  MCI_ANIM_WHERE_DESTINATION = &H40000

'  flags for dwFlags parameter of MCI_UPDATE command message
  MCI_ANIM_UPDATE_HDC = &H20000
End Enum

Public Enum MCICmdsOvlyDevFlags
  MCI_OVLY_OPEN_WS = &H10000
  MCI_OVLY_OPEN_PARENT = &H20000
  
  MCI_OVLY_INFO_TEXT = &H10000
  
  MCI_OVLY_GETDEVCAPS_CAN_STRETCH = &H4001&
  MCI_OVLY_GETDEVCAPS_CAN_FREEZE = &H4002&
  MCI_OVLY_GETDEVCAPS_MAX_WINDOWS = &H4003&
  
  MCI_OVLY_WINDOW_HWND = &H10000
  MCI_OVLY_WINDOW_STATE = &H40000
  MCI_OVLY_WINDOW_TEXT = &H80000
  MCI_OVLY_WINDOW_ENABLE_STRETCH = &H100000
  MCI_OVLY_WINDOW_DISABLE_STRETCH = &H200000
  
  MCI_OVLY_WINDOW_DEFAULT = &H0& ' For Struct
  
  MCI_OVLY_RECT = &H10000
  MCI_OVLY_PUT_SOURCE = &H20000
  MCI_OVLY_PUT_DESTINATION = &H40000
  MCI_OVLY_PUT_FRAME = &H80000
  MCI_OVLY_PUT_VIDEO = &H100000
  
  MCI_OVLY_STATUS_HWND = &H4001&
  MCI_OVLY_STATUS_STRETCH = &H4002&
  
  MCI_OVLY_WHERE_SOURCE = &H20000
  MCI_OVLY_WHERE_DESTINATION = &H40000
  MCI_OVLY_WHERE_FRAME = &H80000
  MCI_OVLY_WHERE_VIDEO = &H100000
End Enum


Public Type MCI_GENERIC_PARMS
  dwCallback As Long
End Type

Public Type MCI_OPEN_PARMS
  dwCallback As Long
  wDeviceID As Long
  lpstrDeviceType As String
  lpstrElementName As String
  lpstrAlias As String
End Type

Public Type MCI_PLAY_PARMS
  dwCallback As Long
  dwFrom As Long
  dwTo As Long
End Type

Public Type MCI_SEEK_PARMS
  dwCallback As Long
  dwTo As Long
End Type

Public Type MCI_STATUS_PARMS
  dwCallback As Long
  dwReturn As Long
  dwItem As Long
  dwTrack As Integer
End Type

Public Type MCI_INFO_PARMS
  dwCallback As Long
  lpstrReturn As String
  dwRetSize As Long
End Type

Public Type MCI_GETDEVCAPS_PARMS
  dwCallback As Long
  dwReturn As Long
  dwIten As Long
End Type

Public Type MCI_SYSINFO_PARMS
  dwCallback As Long
  lpstrReturn As String
  d5wRetSize As Long
  dwNumber As Long
  wDeviceType As Long
End Type

Public Type MCI_SET_PARMS
  dwCallback As Long
  dwTimeFormat As Long
  dwAudio As Long
End Type

Public Type MCI_BREAK_PARMS
  dwCallback As Long
  nVirtKey As Long
  hwndBreak As Long
End Type

Public Type MCI_SOUND_PARMS
  dwCallback As Long
  lpstrSoundName As String
End Type

Public Type MCI_SAVE_PARMS
  dwCallback As Long
  lpFileName As String
End Type

Public Type MCI_LOAD_PARMS
  dwCallback As Long
  lpFileName As String
End Type

Public Type MCI_RECORD_PARMS
  dwCallback As Long
  dwFrom As Long
  dwTo As Long
End Type

' Video Disc structs
Public Type MCI_VD_PLAY_PARMS
  dwCallback As Long
  dwFrom As Long
  dwTo As Long
  dwSpeed As Long
End Type

Public Type MCI_VD_STEP_PARMS
  dwCallback As Long
  dwFrames As Long
End Type

Public Type MCI_VD_ESCAPE_PARMS
  dwCallback As Long
  lpstrCommand As String
End Type

' Wave structures
Public Type MCI_WAVE_OPEN_PARMS
  dwCallback As Long
  wDeviceID As Long
  lpstrDeviceType As String
  lpstrElementName As String
  lpstrAlias As String
  dwBufferSeconds As Long
End Type

Public Type MCI_WAVE_DELETE_PARMS
  dwCallback As Long
  dwFrom As Long
  dwTo As Long
End Type

Public Type MCI_WAVE_SET_PARMS
  dwCallback As Long
  dwTimeFormat As Long
  dwAudio As Long
  wInput As Long
  wOutput As Long
  wFormatTag As Integer
  wReserved2 As Integer
  nChannels As Integer
  wReserved3 As Integer
  nSamplesPerSec As Long
  nAvgBytesPerSec As Long
  nBlockAlign As Integer
  wReserved4 As Integer
  wBitsPerSample As Integer
  wReserved5 As Integer
End Type

' Midi structures
Public Type MCI_SEQ_SET_PARMS
  dwCallback As Long
  dwTimeFormat As Long
  dwAudio As Long
  dwTempo As Long
  dwPort As Long
  dwSlave As Long
  dwMaster As Long
  dwOffset As Long
End Type

' Anim Structures
Public Type MCI_ANIM_OPEN_PARMS
  dwCallback As Long
  wDeviceID As Long
  lpstrDeviceType As String
  lpstrElementName As String
  lpstrAlias As String
  dwStyle As Long
  hWndParent As Long
End Type

Public Type MCI_ANIM_PLAY_PARMS
  dwCallback As Long
  dwFrom As Long
  dwTo As Long
  dwSpeed As Long
End Type

Public Type MCI_ANIM_STEP_PARMS
  dwCallback As Long
  dwFrames As Long
End Type

Public Type MCI_ANIM_WINDOW_PARMS
  dwCallback As Long
  hWnd As Long
  nCmdShow As Long
  lpstrText As String
End Type

Public Type RECT
  Left As Long
  Top As Long
  Right As Long
  Bottom As Long
End Type

' Overlay Video Devices Structs
Public Type MCI_ANIM_RECT_PARMS
  dwCallback As Long
  rc As RECT
End Type

Public Type MCI_ANIM_UPDATE_PARMS
  dwCallback As Long
  rc As RECT
  hdc As Long
End Type

Public Type MCI_OVLY_OPEN_PARMS
  dwCallback As Long
  wDeviceID As Long
  lpstrDeviceType As String
  lpstrElementName As String
  lpstrAlias As String
  dwStyle As Long
  hWndParent As Long
End Type

Public Type MCI_OVLY_WINDOW_PARMS
  dwCallback As Long
  hWnd As Long
  nCmdShow As Long
  lpstrText As String
End Type

Public Type MCI_OVLY_RECT_PARMS
  dwCallback As Long
  rc As RECT
End Type

Public Type MCI_OVLY_SAVE_PARMS
  dwCallback As Long
  lpFileName As String
  rc As RECT
End Type

Public Type MCI_OVLY_LOAD_PARMS
  dwCallback As Long
  lpFileName As String
  rc As RECT
End Type

